package pl.jssoft.test;

import java.io.IOException;
import java.net.URL;
import junit.framework.TestCase;
import org.jbpm.api.Configuration;
import org.jbpm.api.ProcessEngine;
import org.jbpm.api.ProcessInstance;
import org.jbpm.api.task.Task;
import org.junit.Test;


public class SimpleTest extends TestCase
{
	@Test
	public void testPath1()
	{		
		String deploymentId = null;		
		ProcessEngine processEngine = Configuration.getProcessEngine(); 
		
		try
		{
			// deploy process
			URL url = getClass().getClassLoader().getResource("processes/process.jpdl.xml");
			deploymentId = processEngine.getRepositoryService().createDeployment().addResourceFromInputStream("testProcess.jpdl.xml", url.openStream()).deploy();			
					
			// start process
			ProcessInstance pi = processEngine.getExecutionService().startProcessInstanceByKey("testProcess");
			
			// check user task
			Task t = processEngine.getTaskService().findPersonalTasks("username").get(0);
			
			// lets choose simpleform
			processEngine.getTaskService().completeTask(t.getId(), "simple");
			
			// check user task
			t = processEngine.getTaskService().findPersonalTasks("username").get(0);
						
			// in simpleform user sets only var1 and var2 is set tu null for compatibility with next java task
			processEngine.getExecutionService().setVariable(pi.getId(), "user_var1", "Some value");
			processEngine.getExecutionService().setVariable(pi.getId(), "user_var2", null);
			
			// EL exception here! 
			processEngine.getTaskService().completeTask(t.getId(), "next");							
		}
		catch (IOException e)
		{
			e.printStackTrace();
			assert false;			
		}
		catch (Exception e)
		{
			e.printStackTrace();
			assert false;			
		}
		finally
		{
			processEngine.getRepositoryService().deleteDeploymentCascade(deploymentId);			
		}
	}
	
}
